# Pipelined-LC-3b-Processor
 (Implementation of MP3 in ECE418 at UIUC)
 
#### Team project by Aaron Chen, William Miller
 
 Pipelined LC-3bα Processor using SystemVerilog with split L1 128-bit 2-way cache and unified L2 2-way cache.
 
 ![Pipeline](/designs/pipeline.png)
 
 We make some basic rehauls to the MP2 design to greatly optimize its efficiency: a 5-stage pipeline to process multiple instructions at the same time, and a split L1 cache / unified L2 cache to read and write to memory more quickly. To make the pipeline work properly, we also needed to add branch prediction to process instructions efficiently before that branch instruction’s conditions are evaluated. We also needed to include hazard detection and data forwarding so that instructions dependent on previous instructions no longer become an issue. These design differences make our microprocessor much more realistically similar to a modern microprocessor and allow us to understand how one works. We could also evaluate the importance of including other optional features of microprocessors when these design choices were deemed necessary.
 
 In terms of specific tools used to design our microprocessor, our design was not created in physical hardware, but rather using SystemVerilog, a popular hardware description language used to create digital logic circuit of all kinds. We used Altera Quartus to verify and compile our code and Modelsim to simulate our design with particular inputs. We used Gitlab to collaborate and merge our code under the supervision of ECE 411 instructors. 
 
 We effectively designed the most important core parts - the pipeline and cache, but we failed to implement the other advanced features. This was partially due to our team having issues cooperating and not understanding how certain modules in our project were exactly  implemented, so our teamwork was very inefficient. Team members were working on design features in separate git branches without completely understanding how other git branches were implemented and without keeping other teammates accountable for their progress. However this irresponsibility was at least partially due to outside circumstances. As seniors, we all had many other classes and many other obligations due to graduation. As a result, we were all a little bit behind in ECE 411; while we were caught up in MP0 - MP2, we were behind in lectures and had to learn parts of the design while also having to implement it, meaning we had little time to think its design in code thoroughly. In the end, one of our teammates could not handle the workload and left our group, leaving us with only two team members. Our incomplete project was also partially due to simply not spending enough time on the project before checkpoints were due and being unable to keep up with deadlines as our motivation dwindled down.
